//Auto-generated by kalyptus. DO NOT EDIT.
package org.kde.koala;

import org.kde.qt.Qt;
import org.kde.qt.QMetaObject;
import org.kde.qt.QtSupport;
import org.kde.qt.QSize;
import org.kde.qt.QWidget;
import org.kde.qt.QFontDatabase;
import org.kde.qt.QVBox;

/**

 This widget allows the user to select a character of a
 specified font in a table
 \image html kcharselect.png "Character Selection Widget"
 You can specify the font whose characters should be displayed via
 setFont() or in the constructor. Using enableFontCombo() you can allow the
 user to choose the font from a combob-box. As only 256 characters
 are displayed at once in the table, using the spinbox on the top
 the user can choose starting from which character the table
 displays them. This spinbox also can be enabled or disabled using
 enableTableSpinBox().
 KCharSelect supports keyboard and mouse navigation. Click+Move
 always selects the character below the mouse cursor. Using the
 arrow keys moves the focus mark around and pressing RETURN
 or SPACE selects the cell which contains the focus mark.
 To get the current selected character, use the chr()
 method. You can set the character which should be displayed with
 setChar() and the table number which should be displayed with
 setTableNum().
 See {@link KCharSelectSignals} for signals emitted by KCharSelect
		@author Reginald Stadlbauer <reggie@kde.org>
 
		@short Character selection widget.

*/
public class KCharSelect extends QVBox  {
	protected KCharSelect(Class dummy){super((Class) null);}
	public native QMetaObject metaObject();
	public native String className();
	/**	
		 Constructor. <code>font</code> specifies which font should be displayed, <code>chr</code> which character should be selected and <code>tableNum</code> specifies
		 the number of the table which should be displayed.
		     		@short    Constructor.
	*/
	public KCharSelect(QWidget parent, String name, String font, char chr, int tableNum) {
		super((Class) null);
		newKCharSelect(parent,name,font,chr,tableNum);
	}
	private native void newKCharSelect(QWidget parent, String name, String font, char chr, int tableNum);
	public KCharSelect(QWidget parent, String name, String font, char chr) {
		super((Class) null);
		newKCharSelect(parent,name,font,chr);
	}
	private native void newKCharSelect(QWidget parent, String name, String font, char chr);
	public KCharSelect(QWidget parent, String name, String font) {
		super((Class) null);
		newKCharSelect(parent,name,font);
	}
	private native void newKCharSelect(QWidget parent, String name, String font);
	public KCharSelect(QWidget parent, String name) {
		super((Class) null);
		newKCharSelect(parent,name);
	}
	private native void newKCharSelect(QWidget parent, String name);
	/**	
		 Reimplemented.
		     		@short    Reimplemented.
	*/
	public native QSize sizeHint();
	/**	
		 Sets the font which is displayed to <code>font</code>
		     		@short    Sets the font which is displayed to <code>font</code>
	*/
	public native void setFont(String font);
	/**	
		 Sets the currently selected character to <code>chr.</code>
		     		@short    Sets the currently selected character to <code>chr.</code>
	*/
	public native void setChar(char chr);
	/**	
		 Sets the currently displayed table to <code>tableNum.</code>
		     		@short    Sets the currently displayed table to <code>tableNum.</code>
	*/
	public native void setTableNum(int tableNum);
	/**	
		 Returns the currently selected character.
		     		@short    Returns the currently selected character.
	*/
	public native char chr();
	/**	
		 Returns the currently displayed font.
		     		@short    Returns the currently displayed font.
	*/
	public native String fontName();
	/**	
		 Returns the currently displayed table
		     		@short    Returns the currently displayed table
	*/
	public native int tableNum();
	/**	
		 If <code>e</code> is set to true, the combobox which allows the user to
		 select the font which should be displayed is enabled, else
		 disabled.
		     		@short    If <code>e</code> is set to true, the combobox which allows the user to  select the font which should be displayed is enabled, else  disabled.
	*/
	public native void enableFontCombo(boolean e);
	/**	
			 If <code>e</code> is set to true, the spinbox which allows the user to
		 specify which characters of the font should be displayed, is
		 enabled, else disabled.
		     		@short
	*/
	public native void enableTableSpinBox(boolean e);
	/**	
		 Returns wether the font combobox on the top is enabled or
		 disabled.
				@short    Returns wether the font combobox on the top is enabled or  disabled.
		@see #enableFontCombo
	*/
	public native boolean isFontComboEnabled();
	/**	
		 Returns wether the table spinbox on the top is enabled or
		 disabled.
				@short    Returns wether the table spinbox on the top is enabled or  disabled.
		@see #enableTableSpinBox
	*/
	public native boolean isTableSpinBoxEnabled();
	protected native void fillFontCombo();
	protected native void fontSelected(String _font);
	protected native void tableChanged(int _value);
	protected native void charHighlighted(char c);
	protected native void charHighlighted();
	protected native void charActivated(char c);
	protected native void charActivated();
	protected native void charFocusItemChanged();
	protected native void charFocusItemChanged(char c);
	protected native void charTableUp();
	protected native void charTableDown();
	protected native void slotDoubleClicked();
	protected native void slotUnicodeEntered();
	protected native void slotUpdateUnicode(char c);
	protected static native void cleanupFontDatabase();
	/** Deletes the wrapped C++ instance */
	protected native void finalize() throws InternalError;
	/** Delete the wrapped C++ instance ahead of finalize() */
	public native void dispose();
	/** Has the wrapped C++ instance been deleted? */
	public native boolean isDisposed();
}
