//Auto-generated by kalyptus. DO NOT EDIT.
package org.kde.koala;

import org.kde.qt.Qt;
import org.kde.qt.QtSupport;
import org.kde.qt.QVariant;

/**

 KShortcutList is an abstract base class for
 KAccelShortcutList and KStdAccel.ShortcutList. It gives
 you an unified interface for accessing the accelerator lists
 of KAccel (using KAccelShortcutList),
 KGlobalAccel (using KAccelShortcutList), and
 KStdAccel (using KStdAccel.ShortcutList).
		@short Base class for accessing accelerator lists.

*/
public class KShortcutList implements QtSupport {
	private long _qt;
	private boolean _allocatedInJavaWorld = true;
	protected KShortcutList(Class dummy){}


	/**	
		 Default constructor.
			 		@short    Default constructor.
	*/
	/**	
		 Returns the number of entries.
				@return the number of entries
	 
		@short    Returns the number of entries.
	*/
	public native int count();
	/**	
		 Returns the name of the shortcut with the given <code>index.</code>
			@param index the index of the shortcut (must be < count())
				@return the name of the shortcut
	 
		@short    Returns the name of the shortcut with the given <code>index.</code>
	*/
	public native String name(int index);
	/**	
		 Returns the (i18n'd) label of the shortcut with the given <code>index.</code>
			@param index the index of the shortcut (must be < count())
				@return the label (i18n'd) of the shortcut
	 
		@short    Returns the (i18n'd) label of the shortcut with the given <code>index.</code>
	*/
	public native String label(int index);
	/**	
		 Returns the (i18n'd) What's This text of the shortcut with the given <code>index.</code>
			@param index the index of the shortcut (must be < count())
				@return the What's This text (i18n'd) of the shortcut
	 
		@short    Returns the (i18n'd) What's This text of the shortcut with the given <code>index.</code>
	*/
	public native String whatsThis(int index);
	/**	
		 Returns the shortcut with the given <code>index.</code>
			@param index the index of the shortcut (must be < count())
				@return the shortcut

		@short    Returns the shortcut with the given <code>index.</code>
		@see #shortcutDefault
	*/
	public native KShortcut shortcut(int index);
	/**	
		 Returns default shortcut with the given <code>index.</code>
			@param index the index of the shortcut (must be < count())
				@return the default shortcut

		@short    Returns default shortcut with the given <code>index.</code>
		@see #shortcut
	*/
	public native KShortcut shortcutDefault(int index);
	/**	
		 Checks whether the shortcut with the given <code>index</code> is configurable.
			@param index the index of the shortcut (must be < count())
				@return true if configurable, false otherwise
	 
		@short    Checks whether the shortcut with the given <code>index</code> is configurable.
	*/
	public native boolean isConfigurable(int index);
	/**	
		 Sets the shortcut of the given entry
			@param index the index of the shortcut (must be < count())
			@param shortcut the shortcut
			 		@short    Sets the shortcut of the given entry
	*/
	public native boolean setShortcut(int index, KShortcut shortcut);
	/**	
		 Checks whether the shortcut with the given <code>index</code> is saved in the
		 global configuration.
			@param index the index of the shortcut (must be < count())
				@return true if global, false otherwise
	 
		@short    Checks whether the shortcut with the given <code>index</code> is saved in the  global configuration.
	*/
	public native boolean isGlobal(int index);
	/**	
		 Returns the index of the shortcut with he given name.
			@param sName the name of the shortcut to search
				@return the index of the shortcut, of -1 if not found
	 
		@short    Returns the index of the shortcut with he given name.
	*/
	public native int index(String sName);
	/**	
		 Returns the index of the shortcut with he given key sequence.
			@param keySeq the key sequence to search for
				@return the index of the shortcut, of -1 if not found
	 
		@short    Returns the index of the shortcut with he given key sequence.
	*/
	public native int index(KKeySequence keySeq);
	/**	
		 The KInstance.
				@return the KInstance of the list, can be 0 if not available
	 
		@short    The KInstance.
	*/
	public native KInstanceInterface instance();
	/**	 \internal 		@short   \internal
	*/
	public native QVariant getOther(int arg1, int index);
	/**	 \internal 		@short   \internal
	*/
	public native boolean setOther(int arg1, int index, QVariant arg3);
	/**	
		 Save the shortcut list.
				@return true if successful, false otherwise
	 
		@short    Save the shortcut list.
	*/
	public native boolean save();
	/**	
		 Loads the shortcuts from the given configuration file.
			@param sConfigGroup the group in the configuration file
			@param pConfig the configuration file to load from
				@return true if successful, false otherwise
	 
		@short    Loads the shortcuts from the given configuration file.
	*/
	public native boolean readSettings(String sConfigGroup, KConfigBase pConfig);
	public native boolean readSettings(String sConfigGroup);
	public native boolean readSettings();
	/**	
		 Writes the shortcuts to the given configuration file.
			@param sConfigGroup the group in the configuration file
			@param pConfig the configuration file to save to
			@param bWriteAll true to write all actions
			@param bGlobal true to write to the global configuration file
				@return true if successful, false otherwise
	 
		@short    Writes the shortcuts to the given configuration file.
	*/
	public native boolean writeSettings(String sConfigGroup, KConfigBase pConfig, boolean bWriteAll, boolean bGlobal);
	public native boolean writeSettings(String sConfigGroup, KConfigBase pConfig, boolean bWriteAll);
	public native boolean writeSettings(String sConfigGroup, KConfigBase pConfig);
	public native boolean writeSettings(String sConfigGroup);
	public native boolean writeSettings();
}
