//Auto-generated by kalyptus. DO NOT EDIT.
package org.kde.koala;

import org.kde.qt.Qt;
import org.kde.qt.QMetaObject;
import org.kde.qt.QtSupport;
import org.kde.qt.QPixmap;
import org.kde.qt.QWidget;
import org.kde.qt.QObject;

/**

 Displays messages in the window icon and title. The message is usually
 transient with the original title and icon being restored automatically
 after a specified time. The simplest use displays a text message in the
 window title:
 <pre>
    KWindowInfo.showMessage( this, &quot;Message Body&quot; );
 </pre>
 This more complex example changes the window icon, as well as
 displaying the text. In addition, this example overrides the
 default timeout to ensure the message is only displayed for 1
 second.
 <pre>
    QPixmap px;
    px.load( &quot;lo16-app-logtracker.png&quot; );
    KWindowInfo.showMessage( this, &quot;Message Body&quot;, px, 1000 );
 </pre>
 If the parent window inherits KSystemTray then KWindowInfo changes the
 pixmap and tooltip of the system window to display the message.
		@author Richard Moore, rich@kde.org

		@short    Displays messages in the window icon and title.

*/
public class KWindowInfo extends QObject  {
	protected KWindowInfo(Class dummy){super((Class) null);}
	public native QMetaObject metaObject();
	public native String className();
	/**	
		 Creates a KWindowInfo with the specified parent.
		     		@short    Creates a KWindowInfo with the specified parent.
	*/
	public KWindowInfo(QWidget parent, String name) {
		super((Class) null);
		newKWindowInfo(parent,name);
	}
	private native void newKWindowInfo(QWidget parent, String name);
	public KWindowInfo(QWidget parent) {
		super((Class) null);
		newKWindowInfo(parent);
	}
	private native void newKWindowInfo(QWidget parent);
	/**	
		 Returns true iff the object should delete itself when it resets.
		     		@short    Returns true iff the object should delete itself when it resets.
	*/
	public native boolean autoDelete();
	/**	
		 Set to true if you want the object to delete itself when the message
		 timeout occurs.
		     		@short    Set to true if you want the object to delete itself when the message  timeout occurs.
	*/
	public native void setAutoDelete(boolean enable);
	/**	
		 Shows the specified text in the window title.
		     		@short    Shows the specified text in the window title.
	*/
	public native void message(String text);
	/**	
		 Shows the specified text in the window title, and sets the window icon.
		     		@short    Shows the specified text in the window title, and sets the window icon.
	*/
	public native void message(String text, QPixmap pix);
	/**	
		 Shows the specified text in the window title for the specified time.
		     		@short    Shows the specified text in the window title for the specified time.
	*/
	public native void message(String text, int timeout);
	/**	
		 Shows the specified icon and text in the window title and WM
		 icon, for the specified time. The time is a delay specified in
		 milliseconds, or one of the two special values. The special
		 values are -1 which means the default timeout should be used,
		 and 0 which means the message is permanent.
		     		@short    Shows the specified icon and text in the window title and WM  icon, for the specified time.
	*/
	public native void message(String text, QPixmap pix, int timeout);
	/**	
		 Shows the specified text in the window title with no timeout.
		     		@short    Shows the specified text in the window title with no timeout.
	*/
	public native void permanent(String text);
	/**	
		 Shows the specified text and icon in the window title with no timeout.
		     		@short    Shows the specified text and icon in the window title with no timeout.
	*/
	public native void permanent(String text, QPixmap pix);
	/**	
		 Utility method to display a title bar message for the specified
		 window.
		     		@short    Utility method to display a title bar message for the specified  window.
	*/
	public static native void showMessage(QWidget window, String text, int timeout);
	public static native void showMessage(QWidget window, String text);
	/**	
		 Utility method to display a title bar message and icon for the
		 specified window.
		     		@short    Utility method to display a title bar message and icon for the  specified window.
	*/
	public static native void showMessage(QWidget window, String text, QPixmap pix, int timeout);
	public static native void showMessage(QWidget window, String text, QPixmap pix);
	/**	
		 Displays the message in the titlebar/icon.
		     		@short    Displays the message in the titlebar/icon.
	*/
	protected native void display(String text, QPixmap pix);
	/**	
		 Saves the window title and icon.
		     		@short    Saves the window title and icon.
	*/
	protected native void save();
	/**	
		 Resets the window title and icon to the saved values. If
		 auto-delete is enabled then the object is deleted.
		     		@short    Resets the window title and icon to the saved values.
	*/
	protected native void restore();
	/** Deletes the wrapped C++ instance */
	protected native void finalize() throws InternalError;
	/** Delete the wrapped C++ instance ahead of finalize() */
	public native void dispose();
	/** Has the wrapped C++ instance been deleted? */
	public native boolean isDisposed();
}
